Name: gzip
Version: 1.3.5
Release: alt6

Summary: The GNU data compression program
License: GPLv2+
Group: Archiving/Compression
Url: http://www.gnu.org/software/gzip/
Packager: Dmitry V. Levin <ldv@altlinux.org>

# ftp://ftp.gnu.org/gnu/gzip/gzip-%version.tar.gz
# ftp://alpha.gnu.org/gnu/gzip/gzip-%version.tar.gz
Source: gzip-%version.tar
Source1: zme.sh
Source2: zme.1

Patch1: gzip-1.3.5-alt-texinfo.patch
Patch2: gzip-1.3.5-alt-basename.patch
Patch3: gzip-1.3.5-openbsd-owl-alt-tmp.patch
Patch4: gzip-1.3.5-rh-alt-stderr.patch
Patch5: gzip-1.3.5-rh-owl-alt-zgrep.patch
Patch6: gzip-1.3.5-deb-alt-signal.patch
Patch7: gzip-1.3.5-deb-alt-original-filename.patch
Patch8: gzip-1.3.5-alt-copy_stat.patch
Patch9: gzip-1.3.5-alt-bzip2-lzma-xz.patch
Patch10: gzip-1.3.5-alt-znew.patch
Patch11: gzip-1.3.5-gentoo-huft_build-return.patch
Patch12: gzip-1.3.5-google-owl-bound.patch
Patch13: gzip-1.3.5-up-unlzw-CVE-2010-0001.patch

%package utils
Summary: Utilities for handy use of the GNU gzip
Group: Archiving/Compression
Requires: %name = %version-%release, mktemp >= 1:1.3.1
Provides: %name-devel = %version-%release
Obsoletes: %name-devel
Provides: bzip2-utils = 0:1.0.3-alt5
Obsoletes: bzip2-utils
Conflicts: lzma-utils < 0:4.32.9

%description
This package contains the popular GNU gzip data compression
program and its associated scripts to manage compressed files.

%description utils
This package contains additional utilities for the popular
GNU gzip, bzip2, lzma and xz data compression programs.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p0
%patch12 -p1
%patch13 -p1

%build
%define _optlevel 3
%add_optflags %optflags_notraceback
%configure --bindir=/bin
%make_build

%install
mkdir -p %buildroot%_bindir
%makeinstall bindir=%buildroot/bin

for i in zcmp zegrep zforce znew gzexe zdiff zfgrep zgrep; do
	mv %buildroot/bin/$i %buildroot%_bindir/
done

# Replace hardlinks with symlinks.
ln -sf gzip %buildroot/bin/gunzip
ln -sf gzip %buildroot/bin/zcat
ln -sf zdiff %buildroot%_bindir/zcmp
ln -sf zgrep %buildroot%_bindir/zegrep
ln -sf zgrep %buildroot%_bindir/zfgrep

# Add compatibility symlinks.
for i in gzip gunzip zcat; do
	ln -s ../../bin/gzip %buildroot%_bindir/$i
done

# Additional utilities.
for c in b l x; do
	ln -s zdiff %buildroot%_bindir/${c}zcmp
	ln -s zdiff %buildroot%_bindir/${c}zdiff
	ln -s zgrep %buildroot%_bindir/${c}zgrep
	ln -s zgrep %buildroot%_bindir/${c}zegrep
	ln -s zgrep %buildroot%_bindir/${c}zfgrep
done
install -pm755 %_sourcedir/zme.sh %buildroot%_bindir/zme
ln -s zme %buildroot%_bindir/bzme

# Additional manpages.
echo '.so man1/zgrep.1' >%buildroot%_man1dir/zegrep.1
echo '.so man1/zgrep.1' >%buildroot%_man1dir/zfgrep.1
for c in b l x; do
	echo '.so man1/zgrep.1' >%buildroot%_man1dir/${c}zgrep.1
	echo '.so man1/zgrep.1' >%buildroot%_man1dir/${c}zegrep.1
	echo '.so man1/zgrep.1' >%buildroot%_man1dir/${c}zfgrep.1
	echo '.so man1/zdiff.1' >%buildroot%_man1dir/${c}zcmp.1
	echo '.so man1/zdiff.1' >%buildroot%_man1dir/${c}zdiff.1
done
install -pm755 %_sourcedir/zme.1 %buildroot%_man1dir/
ln -s zme.1 %buildroot%_man1dir/bzme.1

# Our zless and zmore live in less package.
rm %buildroot{/bin/z{less,more},%_man1dir/z{less,more}.1}

%files
/bin/*
%_bindir/g*zip
%_bindir/zcat
%_man1dir/g*zip.*
%_man1dir/zcat.*
%_infodir/*.info*
%doc AUTHORS NEWS README THANKS TODO

%files utils
%_bindir/*
%_man1dir/*
%exclude %_bindir/g*zip
%exclude %_bindir/zcat
%exclude %_man1dir/g*zip.*
%exclude %_man1dir/zcat.*

%changelog
* Wed Jan 13 2010 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt6
- Applied upstream fix for integer underflow bug (CVE-2010-0001).

* Fri Sep 25 2009 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt5
- gzip-utils: Added lzma/xz support to zdiff and zgrep.

* Fri Apr 13 2007 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt4
- Rebuilt.

* Mon Sep 18 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt3
- Fixed several bugs (CVE-2006-433[5678])
  based on patch from Tavis Ormandy.
- zgrep: Terminate when pipeline is interrupted by signal (#9998).

* Fri Jul 22 2005 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt2
- Fixed a segfault on invalid compressed data (patch from Gentoo).

* Thu May 19 2005 Dmitry V. Levin <ldv@altlinux.org> 1.3.5-alt1
- Updated to 1.3.5.
- Reviewed and reworked patches.
- Added zegrep(1) and zfgrep(1) manpage links.
- Changed zgrep and zdiff to handle also functionality of
  bz*grep, bzcmp and bzdiff utilities.
- Changed znew utility to avoid dependence on compress utility.
- Relocated zme utility from bzip2-utils to gzip-utils.
- Relocated zmore utility to less package.
- Fixed chmod/chown race condition in file permission handling
  code (CAN-2005-0988).
- Changed gunzip to ignore path in original file name stored
  in gzip archive when uncompressing with -N; this measure
  prohibits uncontrolled files creation in arbitrary filesystem
  locations. (CAN-2005-1228).
- Fixed zgrep to properly sanitize arguments, to avoid arbitrary
  commands execution via filenames injection into a sed script
  (CAN-2005-0758).

* Mon Oct 28 2002 Stanislav Ievlev <inger@altlinux.ru> 1.3.3-alt3
- rebuild with gcc3

* Wed Jun 12 2002 Dmitry V. Levin <ldv@altlinux.org> 1.3.3-alt2
- Added "Provides: /bin/gzip, /bin/gunzip, /bin/zcat" to gzip subpackage.

* Wed Jun 05 2002 Dmitry V. Levin <ldv@altlinux.org> 1.3.3-alt1
- 1.3.3 (nothing interesting).
- Additional convention enforcement on patch file names.

* Sat Jan 19 2002 Dmitry V. Levin <ldv@altlinux.org> 1.3.2-alt2
- Eliminated basename usage in gz* script utils.

* Wed Nov 21 2001 Dmitry V. Levin <ldv@altlinux.org> 1.3.2-alt1
- 1.3.2
- Renamed devel subpackage into %name-utils.

* Tue Nov 20 2001 Dmitry V. Levin <ldv@altlinux.org> 1.3.1-alt1
- 1.3.1
- Updated patches.
- Corrected mktemp dependence.

* Sat Sep 29 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.3-ipl5mdk
- Synced with Owl:
  + Synced with Todd's latest fixes: re-create the temporary file in gzexe
    safely when run on multiple files, support GZIP="--suffix .suf" in znew.
  + Patched unsafe temporary file handling in gzexe, zdiff, and znew based
    on work by Todd Miller of OpenBSD.
  + Dropped Red Hat's patch which attempted to fix some of the same issues
    for gzexe but was far from sufficient.

* Fri Jun 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.3-ipl4mdk
- Merged in RH patches:
  + Patch various uses of $$ in the bundled scripts
  + Fix the SIGPIPE patch to avoid blank lines (#43319)
  + Fixed buzilla bug #26680. Wrong skip value after mktemp patch and forced
    overwrite for output file during decompression.
  + trap SIGPIPE in zgrep, so "zgrep | less" gets a happy ending
    (#24104).

* Sat Dec 02 2000 Dmitry V. Levin <ldv@fandra.org> 1.3-ipl3mdk
- Moved utilities to %name-devel subpackage.
- Removed PreReq: %%__install_info.

* Tue Aug 29 2000 Dmitry V. Levin <ldv@fandra.org> 1.3-ipl2mdk
- Move lesspipe.sh and zless to less package.

* Sat Jun 24 2000 Dmitry V. Levin <ldv@fandra.org> 1.3-ipl1mdk
- 1.3

* Wed May 31 2000 Dmitry V. Levin <ldv@fandra.org> 1.2.4a-ipl1mdk
* RE and Fandra adaptions.

* Sun Apr 02 2000 Jerome Martin <jerome@mandrakesoft.com> 1.2.4a-1mdk
- Updated sources to 1.2.4a (minor doc changes)
- Updated rpm group
- Cleanup to conform to spec-helper

* Wed Mar 08 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 1.2.4-19mdk
- added lesspipe.sh (allowing zless to handle arbitrary compressions
  methods, but also allows to use less command line parameters on zless,
  and use arrows keys to navigate between various files; that is a nice
  and useful zless not one only limited to "zcat $* | less" )

* Thu Dec 16 1999 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Added 4g patch, from www.gzip.org

* Thu Dec 16 1999 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Fixed zforce.

* Wed Oct 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix building as user.

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- built against glibc 2.1

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- added /usr/bin/gzip and /usr/bin/gunzip symlinks as some programs are too
  brain dead to figure out they should be at least trying to use $PATH
- added BuildRoot

* Wed Jan 28 1998 Erik Troan <ewt@redhat.com>
- fix /tmp races

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- uses install-info
- applied patch for gzexe

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Marc Ewing <marc@redhat.com>
- (Entry added for Marc by Erik) fixed gzexe to use /bin/gzip

